/*_TOPICS_
@0:initialization
@1:selection control
@2:rows control
@3:colums control
@4:cells controll
@5:data manipulation
@6:appearence control
@7:overal grid control
@8:tools
@9:treegrid
@10: event handlers
*/

var globalActiveDHTMLGridObject;
String.prototype.trim = function(){
							return this.replace(/&nbsp;/g," ").replace(/(^[ \t]*)|([ \t]*$)/g,"");
						}
Array.prototype.find = function(pattern){
	for(var i=0;i<this.length;i++){
		if(pattern==this[i])
				return i;
	}
	return -1;
}
Array.prototype.delAt = function(ind){
	if(Number(ind)<0 || this.length==0) 
		return false;
	for(var i=ind;i<this.length;i++){
		this[i]=this[i+1];
	}
	this.length--;
}
Array.prototype.insertAt = function(ind,value){
	this[this.length] = null;
	for(var i=this.length-1;i>=ind;i--){
		this[i] = this[i-1]
	}
	this[ind] = value
}
Array.prototype.removeAt = function(ind){
	for(var i=ind;i<this.length;i++){
		this[i] = this[i+1]
	}
	this.length--;
}	
Array.prototype.swapItems = function(ind1,ind2){
	var tmp = this[ind1];
	this[ind1] = this[ind2]
	this[ind2] = tmp;
}
	
/**
*	@desc: dhtmlxGrid constructor
*	@param: id - (optional) id of div element to base grid on
*	@returns: dhtmlxGrid object
*	@type: public
*/
function dhtmlXGridObject(id){
	if(id){
		if(typeof(id)=='object'){
			this.entBox = id
			this.entBox.id = "cgrid2_"+(new Date()).getTime();
		}else
			this.entBox = document.getElementById(id);
	}else{
		this.entBox = document.createElement("DIV");
		this.entBox.id = "cgrid2_"+(new Date()).getTime();
	}
	var self = this;
	this.nm = this.entBox.nm || "grid";
	this.cell = null;
	this.row = null;
	this.editor=null;
	this.combos=new Array(0);
	this.rowsAr = new Array(0);//array of rows by idd
	this.rowsCol = new Array(0);//array of rows by index
	this.selectedRows = new Array(0);//selected rows array
	this.rowsBuffer = new Array(new Array(0),new Array(0));//buffer of rows loaded, but not rendered (array of ids, array of cell values arrays)
	this.loadedKidsHash = null;//not null if there is tree cell in grid
	this.UserData = new Array(0)//array of rows (and for grid - "gridglobaluserdata") user data elements
/*MAIN OBJECTS*/
		
	this.styleSheet = document.styleSheets[0];
		this.entBox.className = "gridbox";
		this.entBox.style.width = this.entBox.getAttribute("width") || "100%";
		this.entBox.style.height = this.entBox.getAttribute("height") || "100%";
		//cursor and text selection
		this.entBox.style.cursor = 'default';
		this.entBox.onselectstart = function(){return false};//avoid text select
	this.obj = document.createElement("TABLE");
		this.obj.cellSpacing = 0;
		this.obj.cellPadding = 0;
		this.obj.style.width = "100%";//nb:
		this.obj.style.tableLayout = "fixed";
		this.obj.className = "obj";
	this.hdr = document.createElement("TABLE");
		this.hdr.cellSpacing = 0;
		this.hdr.cellPadding = 0;
		this.hdr.style.tableLayout = "fixed";
		this.hdr.className = "hdr";
		this.hdr.width = "100%";
	this.xHdr = document.createElement("TABLE");
		this.xHdr.cellPadding = 0;
		this.xHdr.cellSpacing = 0;
		var r = this.xHdr.insertRow(0)
		var c = r.insertCell(0);
			r.insertCell(1).innerHTML = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			c.appendChild(this.hdr)
	this.objBuf = document.createElement("DIV");
		this.objBuf.style.borderBottom = "1px solid white"
		this.objBuf.appendChild(this.obj);
	this.entCnt = document.createElement("TABLE");
		this.entCnt.insertRow(0).insertCell(0)
		this.entCnt.insertRow(1).insertCell(0);
		this.entCnt.cellPadding = 0;
		this.entCnt.cellSpacing = 0;
		this.entCnt.width = "100%";
		this.entCnt.height = "100%";
		this.entCnt.style.tableLayout = "fixed";
	this.objBox = document.createElement("DIV");
		this.objBox.style.width = "100%"
		this.objBox.style.height = this.entBox.style.height;
		this.objBox.style.overflow = "auto";
		this.objBox.style.position = "relative";
		this.objBox.appendChild(this.objBuf);
		this.objBox.className = "objbox";
	this.hdrBox = document.createElement("DIV");
		this.hdrBox.style.width = "100%"
		this.hdrBox.style.height="100px";
		this.hdrBox.style.overflow = "auto";
		this.hdrBox.style.position = "relative";
		this.hdrBox.appendChild(this.xHdr);
	this.sortImg = document.createElement("IMG")
	this.hdrBox.insertBefore(this.sortImg,this.xHdr)
	this.entCnt.rows[0].cells[0].appendChild(this.hdrBox);
	this.entCnt.rows[1].cells[0].appendChild(this.objBox);
	
	this.entBox.appendChild(this.entCnt);
	//add links to current object
	this.entBox.grid = this;
	this.objBox.grid = this;
	this.hdrBox.grid = this;
	this.obj.grid = this;
	this.hdr.grid = this;
/*PROPERTIES*/
	this.cellWidthPX = new Array(0);//current width in pixels
	this.cellWidthPC = new Array(0);//width in % if cellWidthType set in pc
	this.cellWidthType = this.entBox.cellwidthtype || "px";//px or %
	
	this.delim = this.entBox.delimiter || ",";
	this.hdrLabels = (this.entBox.hdrlabels || "").split(",");
	this.columnIds = (this.entBox.columnids || "").split(",");
	this.columnColor = (this.entBox.columncolor || "").split(",");
	this.cellType =  (this.entBox.cellstype || "").split(",");
	this.cellAlign =  (this.entBox.cellsalign || "").split(",");
	this.initCellWidth = (this.entBox.cellswidth || "").split(",");
	this.fldSort = (this.entBox.fieldstosort || "").split(",")
	this.imgURL = this.entBox.imagesurl || "gridCfx";
	this.isActive = false;//fl to indicate if grid is in work now
	this.isEditable = true;
	this.raNoState = this.entBox.ranostate || "N";
	this.chNoState = this.entBox.chnostate || "N";
	this.selBasedOn = (this.entBox.selbasedon || "cell").toLowerCase()
	this.selMultiRows = this.entBox.selmultirows || false;
	this.multiLine = this.entBox.multiline || false;
	this.noHeader = this.entBox.noheader || false;
	this.dynScroll = this.entBox.dynscroll || false;//add/remove rows from dom
	this.dynScrollPageSize = 0;//will be autodetected
	this.dynScrollPos = 0;//position of dynamic scroll
	this.xmlFileUrl = this.entBox.xmlfileurl || "";
	this.recordsNoMore = this.entBox.infinitloading || true;;//if true, then it will not attempt to fill the buffer from server
	
	//this.dynScrollBuffer = 100;//number of rows in buffer
	this.rowsBufferOutSize = 0;//number of rows rendered at a moment
/*EVENTS*/
	this.onCheckbox = this.entBox.oncheckbox || "void";//rId,state,cInd
	this.onEditCell = this.entBox.oneditcell || "void";//fl,rid,cInd
	this.onRowSelect = this.entBox.onrowselect || "void";//rId,false
	this.onEnter = this.entBox.onenter || "void";//rId,cin
/*XML LOADER(S)*/
	this.loadXML = function(url){
		if(url.indexOf("?")!=-1)
			var s = "&";
		else
			var s = "?";
		this.xmlLoader.loadXML(url+""+s+"rowsLoaded="+this.getRowsNum()+"&lastid="+this.getRowId(this.getRowsNum()-1)+"&sn="+Date.parse(new Date()));
	}
	this.doLoadDetails = function(obj){
		var root = self.xmlLoader.getXMLTopNode("rows")
		self.parseXML(self.xmlLoader.xmlDoc)	
	}
	this.xmlLoader = new dtmlXMLLoaderObject(this.doLoadDetails,window);
	
/*METHODS. SERVICE*/
		/**
		*	@desc: on scroll grid inside actions
		*	@type: private
		*	@topic: 7
		*/
		this.doOnScroll = function(){
						this.hdrBox.scrollLeft = this.objBox.scrollLeft; 
						this.setSortImgPos()
						if(this.objBox.scrollTop+100+this.objBox.offsetHeight>this.objBox.scrollHeight){
							if(this.addRowsFromBuffer())
								this.objBox.scrollTop = this.objBox.scrollHeight - (101+this.objBox.offsetHeight)
						}
					}
		/**
		* 	@desc: attach this grid to some object in DOM
		* 	@param: obj - object to attach to
		*	@type: public
		*	@topic: 0,7
		*/
		this.attachToObject = function(obj){
								obj.appendChild(this.entBox)
								
							}
		/**
		*	@desc: initialize grid
		*	@param: fl - if to parse on page xml dataisland
		*	@type: public
		*	@topic: 0,7
		*/
		this.init = 	function(fl){
							//debugger;
							this.editStop()
							/*TEMPORARY STATES*/
							this.lastClicked = null;//row clicked without shift key. used in multiselect only
							this.resized = null;//hdr cell that is resized now 
							this.fldSorted = null;//hdr cell last sorted
							this.gridWidth = 0;
							this.gridHeight = 0;
							//empty grid if it already was initialized
							this.cellWidthPX = new Array(0);
							this.cellWidthPC = new Array(0);
							if(this.hdr.rows.length>0){
								this.clearAll();
								this.hdr.rows[0].removeNode(true);//this.hdr.firstChild.removeChild(this.hdr.rows[0])
							}
							if(this.cellType.find("tree")!=-1){//create hashtable for treegrid
								this.loadedKidsHash = new Hashtable();
								this.loadedKidsHash.put("hashOfParents",new Hashtable())
							}
							var hdrRow = this.hdr.insertRow(0);
							for(var i=0;i<this.hdrLabels.length;i++){
								hdrRow.insertCell(i).innerHTML = this.hdrLabels[i];
							}
							this.setColumnIds()
							if(this.multiLine==-1)
								this.multiLine = true;
							else
								this.multiLine = false;
							//
							//this.combos = new Array(this.hdrLabels.length);
							//set sort image to initial state
							this.sortImg.style.position = "absolute";
							this.sortImg.style.display = "none";
							this.sortImg.src = this.imgURL+"sort_desc.gif";
							this.sortImg.defLeft = 0;
							//create and kill a row to set initial size
							//this.addRow("deletethisrtowafterresize",new Array("",""))
							this.entCnt.rows[0].style.display = ''//display header
							//alert(this.entCnt.rows[0].innerHTML)
							if(this.noHeader==-1){
								this.noHeader = true
								this.entCnt.rows[0].style.display = 'none';
							}else{
								this.noHeader = false
							}	
							this.setSizes();
							//this.deleteRow("deletethisrtowafterresize")
							//parse inline xml
							if(fl)
								this.parseXML()
							
						};
		/**
		* 	@desc: sets sizes of grid elements
		*	@type: private
		*	@topic: 0,7
		*/
		this.setSizes  = 	function(fl){
							if(fl && this.gridWidth==this.entBox.offsetWidth && this.gridHeight==this.entBox.offsetHeight){
								return false
							}else if(fl){
								this.gridWidth = this.entBox.offsetWidth
								this.gridHeight = this.entBox.offsetHeight
							}
							try{
								this.entCnt.rows[0].cells[0].height = this.hdrBox.offsetHeight;
							}catch(er){}
							var gridWidth = parseInt(this.entBox.offsetWidth);
							var gridHeight = parseInt(this.entBox.offsetHeight);
							var len = this.hdr.rows[0].cells.length
							for(var i=0;i<this.hdr.rows[0].cells.length;i++){
								if(this.cellWidthType=='px' && this.cellWidthPX.length < len){
									this.cellWidthPX[i] = this.initCellWidth[i];
								}else if(this.cellWidthType=='%' && this.cellWidthPC.length < len){
									this.cellWidthPC[i] = this.initCellWidth[i];
								}
								if(this.cellWidthPC.length!=0){
									this.cellWidthPX[i] = parseInt(gridWidth*this.cellWidthPC[i]/100)
								}
							}
							this.chngCellWidth(this.rowsCol.find(this.obj.rows[0]))
							var summ = 0;
							for(var i=0;i<this.cellWidthPX.length;i++)
								summ += parseInt(this.cellWidthPX[i])
							this.objBuf.style.width = summ
							//set auto page size of dyn scroll
							this.doOnScroll();
							
							//set header part of container visible height to header's height
							//this.entCnt.rows[0].cells[0].style.height = this.hdr.offsetHeight;
							if(!this.noHeader){
								this.entCnt.rows[1].cells[0].childNodes[0].style.top = this.hdr.offsetHeight-100+1;
								this.entCnt.rows[1].cells[0].childNodes[0].style.height = gridHeight - this.hdr.offsetHeight
								//this.objBox.style.height = gridHeight;
							}
						};
		
		/**
		*	@desc: changes cell width
		*	@param: [ind] - index of row in grid
		*	@type: private
		*	@topic: 4,7
		*/
		this.chngCellWidth = function(ind){
									if(!ind)
										var ind = 0;
									for(var i=0;i<this.cellWidthPX.length;i++){
										this.hdr.rows[0].cells[i].style.width = this.cellWidthPX[i];
										if(this.rowsCol[ind])
											this.rowsCol[ind].cells[i].style.width = this.cellWidthPX[i];
									}
								}
		/**
		*	@desc: set default delimiter 
		*	@param: delim - delimiter as string
		*	@before_init: 1
		*	@type: public
		*	@topic: 0
		*/
		this.setDelimiter = function(delim){
			this.delim = delim;
		}
		/**
		*	@desc: set width of columns in percents
		*	@type: public
		*	@before_init: 1
		*	@param: wp - width in percents
		*	@topic: 0,7
		*/
		this.setInitWidthsP = function(wp){
			this.cellWidthType = "%";
			this.initCellWidth = wp.split(this.delim);
		}
		/**
		*	@desc: set width of columns in pixels
		*	@type: public
		*	@before_init: 1
		*	@param: wp - width in pixels
		*	@topic: 0,7
		*/
		this.setInitWidths = function(wp){
			this.cellWidthType = "px";
			this.initCellWidth = wp.split(this.delim);
		}
		
		/**
		*	@desc: set multiline rows support to enabled or disabled state
		*	@type: public
		*	@before_init: 1
		*	@param: state - true or false
		*	@topic: 0,7
		*/
		this.enableMultiline = function(state){
			this.multiLine = state;
		}
		
		/**
		*	@desc: set multiselect mode to enabled or disabled state
		*	@type: public
		*	@param: state - true or false
		*	@topic: 0,7
		*/
		this.enableMultiselect = function(state){
			this.selMultiRows = state;
		}
		
		/**
		*	@desc: set path to grid internal images (sort direction, any images used in editors, checkbox, radiobutton)
		*	@type: public
		*	@param: path - path to images folder with closing "/"
		*	@topic: 0,7
		*/
		this.setImagePath = function(path){
			this.imgURL = path;
		}
		
		/**
		*	@desc: part of column resize routine
		*	@type: private
		*	@param: ev - event
		*	@topic: 3
		*/
		this.changeCursorState = function (ev){
									var el = ev.target||ev.srcElement;
									//alert(el.offsetWidth+" - "+(ev.offsetX||(parseInt(this.getPosition(el,this.hdrBox))-ev.layerX)*-1))
									if((el.offsetWidth - (ev.offsetX||(parseInt(this.getPosition(el,this.hdrBox))-ev.layerX)*-1))<10){
										el.style.cursor = "E-resize";
									}else
										el.style.cursor = "default";
								}
		/**
		*	@desc: part of column resize routine
		*	@type: private
		*	@param: ev - event
		*	@topic: 3
		*/
		this.startColResize = function(ev){
									this.resized = null;
									var el = ev.target||ev.srcElement;
									var x = ev.layerX||ev.x;
									//alert(x)
									var tabW = this.hdr.offsetWidth;
									var startW = parseInt(el.offsetWidth)
									if(el.tagName=="TD" && el.style.cursor!="default"){
										this.entBox.onmousemove = function(e){this.grid.doColResize(e||window.event,el,startW,x,tabW)}
										document.body.onmouseup = new Function("","document.getElementById('"+this.entBox.id+"').grid.stopColResize()");
									}
								}
		/**
		*	@desc: part of column resize routine
		*	@type: private
		*	@param: ev - event
		*	@topic: 3
		*/
		this.stopColResize = function(){
									this.entBox.onmousemove = "";//removeEventListener("mousemove")//
									document.body.onmouseup = "";
									this.setSizes();
									this.doOnScroll()
								}
		/**
		*	@desc: part of column resize routine
		*	@param: el - element (column resizing)
		*	@param: startW - started width
		*	@param: x - x coordinate to resize from
		*	@param: tabW - started width of header table
		*	@type: private
		*	@topic: 3
		*/
		this.doColResize = function(ev,el,startW,x,tabW){
								el.style.cursor = "E-resize";
								this.resized = el;
								var fcolW = startW + ((ev.layerX||ev.x)-x);
								var wtabW = tabW + ((ev.layerX||ev.x)-x)
								if(fcolW>10){
									el.style.width = fcolW
									if(this.rowsCol.length>0)
										this.rowsCol[this.rowsCol.find(this.obj.rows[0])].cells[el.cellIndex].style.width = fcolW
									if(this.cellWidthType=='px'){
										this.cellWidthPX[el.cellIndex]=fcolW;
									}else{
										var pcWidth = parseInt(fcolW/this.entBox.offsetWidth*100)
										this.cellWidthPC[el.cellIndex]=pcWidth;
									}
									this.doOnScroll()
								}
							}
		
		
		
		/**
		* 	@desc: sets position and visibility of sort image
		* 	@param: [ind] - index of field
		*	@type: private
		*	@topic: 7
		*/
		this.setSortImgPos = function(ind){
									if(!ind)
										var el = this.fldSorted;
									else
										var el = this.hdr.cells[ind];
									if(el!=null){
										var pos = this.getPosition(el,this.hdrBox)
										var wdth = el.offsetWidth;
										this.sortImg.style.left = Number(pos[0]+wdth-13)+"px";//Number(pos[0]+5)+"px";
										this.sortImg.defLeft = parseInt(this.sortImg.style.left)
										this.sortImg.style.top = Number(pos[1]+5)+"px";
										this.sortImg.style.display = "inline";
										this.sortImg.style.left = this.sortImg.defLeft;//-parseInt(this.hdrBox.scrollLeft)
									}
								}
		/**
		* 	@desc: populate grid with data from xml file (if passed parameter contains '.') or island
		* 	@param: [xml] - xml island will be found by grid id (id_xml) if no file or island id is specified. This also can be ready-to-use XML object
		*	@param: [startIndex] - index of row in grid to start insertion from
		*	@type: public
		*	@topic: 2,5
		*/
		this.parseXML = function(xml,startIndex){ 
					//debugger;
							try{
								if(!xml)
									try{
										var xmlDoc = eval(this.entBox.id+"_xml").XMLDocument;
									}catch(er){
										var xmlDoc = this.loadXML(this.xmlFileUrl)
									}
								else{
									if(typeof(xml)=="object"){
										var xmlDoc = xml;
									}else{
										if(xml.indexOf(".")!=-1){
											if(this.xmlFileUrl=="")
												this.xmlFileUrl = xml
											var xmlDoc = this.loadXML(xml)
										}else
											var xmlDoc = eval(xml).XMLDocument;
									}
								}
								//debugger;
								var rowsCol = this.xmlLoader.doXPath("//rows/row");
								if(rowsCol.length==0){
									this.recordsNoMore = true;
								}
								var ar = new Array();
								var idAr = new Array();
								//global(grid) user data
								var gudCol = this.xmlLoader.doXPath("//rows/userdata");
								if(gudCol.length>0){
									this.UserData["gridglobaluserdata"] = new Array(0)
									for(var j=0;j<gudCol.length;j++){
										this.UserData["gridglobaluserdata"][gudCol[j].getAttribute("name")] = isIE()?gudCol[j].text:gudCol[j].textContent;
									}
								}
								//rows
								//debugger;
								for(var i=0;i<rowsCol.length;i++){
									if(i<=this.rowsBufferOutSize || this.rowsBufferOutSize==0){
										var rId = rowsCol[i].getAttribute("id")
										//user data	
										var udCol = this.xmlLoader.doXPath(".//userdata",rowsCol[i]);
										if(udCol.length>0){
											this.UserData[rId] = new Array(0)
											for(var j=0;j<udCol.length;j++){
												this.UserData[rId][udCol[j].getAttribute("name")] = isIE()?udCol[j].text:udCol[j].textContent;
											}
										}
										var cellsCol = this.xmlLoader.doXPath(".//cell",rowsCol[i]);
										var strAr = new Array(0);
										for(var j=0;j<cellsCol.length;j++){
											strAr[strAr.length] = isIE()?cellsCol[j].text:cellsCol[j].textContent;
										}
										if(startIndex){
											var r = this.addRow(rId,strAr,startIndex)
											startIndex++;
										}else{
											var r = this.addRow(rId,strAr)
										}
										//select row
										if(rowsCol[i].getAttribute("selected")==true){
											this.setSelectedRow(rId,false,false,rowsCol[i].getAttribute("call")==true)
										}
										//expand row
										if(rowsCol[i].getAttribute("expand")=="1"){
											r.expand = "";
										}
									}else{
										var len = this.rowsBuffer[0].length
										this.rowsBuffer[1][len] = rowsCol[i]
										this.rowsBuffer[0][len] = rowsCol[i].getAttribute("id")
										//this.rowsBuffer[1][len] = ar[i]
									}
									
								}
								
								if(this.dynScroll && this.dynScroll!='false'){
									//alert("do scroll "+this.dynScrollPos)
									this.doDynScroll()
								}
							}catch(er){
								//alert(er.description)
							}
							//refresh content (for Mozilla)
							this.objBox.style.height = parseInt(this.entBox.getAttribute("height"))-parseInt(this.hdr.offsetHeight);
						}
		/**
		*	@desc: manage activity of the grid.
		*	@param: fl - true to activate,false to deactivate 
		*	@type: private
		*	@topic: 1,7
		*/
		this.setActive = function(fl){
							if(arguments.length==0)
								var fl = true;
							if(fl==true){	
								document.body.onkeydown = new Function("","document.getElementById('"+this.entBox.id+"').grid.doKey()")//
								globalActiveDHTMLGridObject = this;
								this.isActive = true;
							}else{
								this.isActive = false;
							}
						};
		/**
		*	  @desc: called on click occured
		*     @type: private
		*/
		this._doClick = function(ev){
							var selMethod = 0;
							var el = this.getFirstParentOfType(isIE()?ev.srcElement:ev.target,"TD");
							var fl = true;
							if(this.selMultiRows!=false){
								if(ev.shiftKey && this.row!=null){
									selMethod = 1;
								}
								if(ev.ctrlKey){
									selMethod = 2;
								}
								if(!ev.shiftKey)
									this.lastClicked = el.parentNode;
							}
							this.doClick(el,fl,selMethod)
						};
		/**
		* 	@desc: occures on cell click (supports treegrid)
		*	@param: [el] - cell to click on
		*	@param:	[fl] - true if to call onRowSelect function
		*	@param: [selMethod] - 0 - simple click, 1 - shift, 2 - ctrl
		*	@type: private
		*	@topic: 1,2,4,9
		*/
		this.doClick = 	function(el,fl,selMethod){
							this.setActive(true);
							if(!selMethod)
								selMethod = 0;
							if(this.cell!=null)
								this.cell.className = "";
							if(el.tagName=="TD" && this.rowsCol.find(this.rowsAr[el.parentNode.idd])!=-1){
								if(selMethod==0){
									this.clearSelection();
								}else if(selMethod==1){
									var elRowIndex = this.rowsCol.find(el.parentElement)
									var lcRowIndex = this.rowsCol.find(this.lastClicked)
									if(elRowIndex>lcRowIndex){
										var strt = lcRowIndex;
										var end = elRowIndex;
									}else{
										var strt = elRowIndex;
										var end = lcRowIndex;
									}
									this.clearSelection();
									for(var i=0;i<this.rowsCol.length;i++){
										if(i>=strt && i<=end){
											this.rowsCol[i].className = "rowselected";
											this.selectedRows[this.selectedRows.length] = this.rowsCol[i]
										}/*else{
											this.rowsCol[i].className = "";
										}*/
									}
									
								}else if(selMethod==2){
									if(el.parentNode.className == "rowselected"){
										el.parentNode.className = "";
										this.selectedRows.removeAt(this.selectedRows.find(el.parentNode))
										var skipRowSelection = true;
									}
								}
								this.editStop()
								this.cell = el;
								if(this.row != el.parentNode){//if new row selected
									this.row = el.parentNode;
									if(fl)
										if(typeof(this.onRowSelect)=="string")
											setTimeout(this.onRowSelect+"('"+this.row.idd+"',false);",100)//outside function call
										else{
											var rid = this.row.idd
											var func = this.onRowSelect
											setTimeout(function(){func(rid,false);},100)
										}
								}
								if(this.selBasedOn=="cell"){
									this.cell.className = "cellselected"
								}
								if(!skipRowSelection){
									this.row.className = "rowselected"
									if(this.selectedRows.find(this.row)==-1)
										this.selectedRows[this.selectedRows.length] = this.row;
								}
							}
							this.isActive = true;
							this.moveToVisible(this.cell)
						}
		/**
		*	@desc: set selection to specified row-cell
		*	@param: r - row object or row index
		*	@param: cInd - cell index
		*	@param: [fl] - true if to call onRowSelect function 
		*	@type: public
		*	@topic: 1,4
		*/
		this.selectCell = function(r,cInd,fl){
							if(!fl)
								fl = false;
							if(typeof(r)!="object")
								r = this.rowsCol[r]
							var c = r.childNodes[cInd];
							this.doClick(c,fl)
						}
		/**
		*	@desc: moves specified cell to visible area (scrolls)
		*	@param: cell_obj - object of the cell to work with
		*	@type: private
		*	@topic: 2,4,7
		*/
		this.moveToVisible = function(cell_obj){
							try{
								var distance = cell_obj.offsetLeft+cell_obj.offsetWidth+20;
								if(distance>(this.objBox.offsetWidth+this.objBox.scrollLeft)){
									var scrollLeft = distance - this.objBox.offsetWidth;
								}else if(cell_obj.offsetLeft<this.objBox.scrollLeft){
									var scrollLeft =  cell_obj.offsetLeft-5
								}
								if(scrollLeft)	
									this.objBox.scrollLeft = scrollLeft;
								
								var distance = cell_obj.offsetTop+cell_obj.offsetHeight + 20;
								if(distance>(this.objBox.offsetHeight+this.objBox.scrollTop)){
									var scrollTop = distance - this.objBox.offsetHeight;
								}else if(cell_obj.offsetTop<this.objBox.scrollTop){
									var scrollTop =  cell_obj.offsetTop-5
								}
								if(scrollTop)	
									this.objBox.scrollTop = scrollTop;
							}catch(er){
								//alert("Caught Error in moveToVisible: "+ er.description)
							}
						}
		/**
		*	@desc: creates Editor object and switch cell to edit mode if allowed
		*	@type: public
		*	@topic: 4
		*/
		this.editCell = function(){
							this.editStop();
							if(this.isEditable!=true)
								return false;
							var c = this.cell
							eval("this.editor = new eXcell_"+this.cellType[this.cell.cellIndex]+"(c)");
							//initialize editor
							if(this.editor!=null){
								if(typeof(this.onEditCell)=="string"){
									if(eval(this.onEditCell+"(0,'"+this.row.idd+"',"+this.cell.cellIndex+");")!=false){
										this.editor.edit()
										eval(this.onEditCell+"(1,'"+this.row.idd+"',"+this.cell.cellIndex+");")
									}else{//preserve editing
										this.editor=null;
									}
								}else{
									if(this.onEditCell(0,this.row.idd,this.cell.cellIndex)!=false){
										this.editor.edit()
										this.onEditCell(1,this.row.idd,this.cell.cellIndex)
									}else{//preserve editing
										this.editor=null;
									}
								}
							}
						}
		/**
		*	@desc: gets value from editor(if presents) to cell and closes editor
		*	@type: public
		*	@topic: 4
		*/
		this.editStop = function(){
							if(this.editor && this.editor!=null){
								this.cell.wasChanged = this.editor.detach();
								if(typeof(this.onEditCell)=="string")
									eval(this.onEditCell+"(2,'"+this.row.idd+"',"+this.cell.cellIndex+");")
								else
									this.onEditCell(2,this.row.idd,this.cell.cellIndex);
							}
							this.editor=null;
						}
		/**
		*	@desc: manages keybord activity in grid
		*	@type: private
		*	@topic: 7
		*/
		this.doKey =	function(ev){
							if(this.isActive==false){
								document.body.onkeydown = "";
								return false;
							}	
							try{
								var type = this.cellType[this.cell.cellIndex]
								//ENTER
								if(ev.keyCode==13 && (ev.ctrlKey || ev.shiftKey)){
									var rowInd = this.rowsCol.find(this.row)
									if(window.event.ctrlKey && rowInd!=this.rowsCol.length-1){
										if(this.row.rowIndex==this.obj.rows.length-1 && this.dynScroll && this.dynScroll!='false')
											this.doDynScroll("dn")
										this.selectCell(this.rowsCol[rowInd+1],this.cell.cellIndex,true);
									}else if(ev.shiftKey && rowInd!=0){
										if(this.row.rowIndex==0 && this.dynScroll && this.dynScroll!='false')
											this.doDynScroll("up")
										this.selectCell(this.rowsCol[rowInd-1],this.cell.cellIndex,true);
									}
									isIE()?ev.returnValue=false:ev.preventDefault();
								}
								if(ev.keyCode==13 && !ev.ctrlKey && !ev.shiftKey){
									this.editStop();
									if(typeof(this.onEnter)=="string")
										eval("window."+this.onEnter+"('"+this.row.idd+"',"+this.cell.cellIndex+")")
									else
										this.onEnter(this.row.idd,this.cell.cellIndex);
									isIE()?ev.returnValue=false:ev.preventDefault();
								}
								//TAB
								if(ev.keyCode==9 && !ev.shiftKey && this.cell.cellIndex!=this.rowsCol[0].cells.length-1){
									this.selectCell(this.row,this.cell.cellIndex+1);
									this.editCell()
									isIE()?ev.returnValue=false:ev.preventDefault();
								}else if(ev.keyCode==9 && ev.shiftKey && this.cell.cellIndex!=0){
									this.selectCell(this.row,this.cell.cellIndex-1);
									this.editCell()
									isIE()?ev.returnValue=false:ev.preventDefault();
								}
								//UP & DOWN
								if(ev.keyCode==40 || ev.keyCode==38){//&& ev.ctrlKey
									var rowInd = this.row.rowIndex;//rowsCol.find(this.row)
									if(ev.keyCode==38 && rowInd!=0){
										if(this.row.rowIndex==0 && this.dynScroll && this.dynScroll!='false')
											this.doDynScroll("up")
										this.selectCell(this.obj.rows[rowInd-1],this.cell.cellIndex,true);
									}else if(ev.keyCode==40 && rowInd!=this.rowsCol.length-1){
										if(this.row.rowIndex==this.obj.rows.length-1 && this.dynScroll && this.dynScroll!='false')
											this.doDynScroll("dn")
										this.selectCell(this.obj.rows[rowInd+1],this.cell.cellIndex,true);
									}
									isIE()?ev.returnValue=false:ev.preventDefault();
								}
								//F2
								if(ev.keyCode==113){
									this.editCell();
									return false;
								}
								//SPACE
								if(ev.keyCode==32){// && (type=='ch'|| type.indexOf('ra')==0)){
									var c = this.cell
									eval("var ed = new eXcell_"+this.cellType[c.cellIndex]+"(c)");
									//this.cell.children(0).click()
									if(ed.changeState()!=false)
										isIE()?ev.returnValue=false:ev.preventDefault();
								}
								//Esc
								if(ev.keyCode==27 && this.oe!=false){
									this.editStop();
									isIE()?ev.returnValue=false:ev.preventDefault();
								}
								//PAGEUP / PAGEDOWN
								if(ev.keyCode==33 || ev.keyCode==34){
									if(ev.keyCode==33)
										this.doDynScroll("up")
									else
										this.doDynScroll("dn")
									isIE()?ev.returnValue=false:ev.preventDefault();
								}
								//RIGHT LEFT
								if(ev.keyCode==37 && this.cellType.find("tree")!=-1){
									this.collapseKids(this.row)
									isIE()?ev.returnValue=false:ev.preventDefault();
								}
								if(ev.keyCode==39 && this.cellType.find("tree")!=-1){
									this.expandKids(this.row)
									isIE()?ev.returnValue=false:ev.preventDefault();
								}
								return true;
							}catch(er){}
						}
	/**
	*	@desc: selects row (?)for comtatibility with previous version
	*	@param: cell - cell object(or cell's child)
	*	@invoke: click on cell(or cell content)
	*	@type: private
	*	@topic: 1,2
	*/
	this.getRow = function(cell){
						if(!cell)
							cell = window.event.srcElement;
						if(cell.tagName!='TD')
							cell = cell.parentElement;
						r = cell.parentElement;
						if(this.cellType[cell.cellIndex]=='lk')
							eval(this.onLink+"('"+this.getRowId(r.rowIndex)+"',"+cell.cellIndex+")");
						this.selectCell(r,cell.cellIndex,true)
					}
	/**
	*	@desc: selects row (and first cell of it)
	*	@param: r - row index or row object
	*	@param: fl - if true, then call function on select
	*	@type: public
	*	@topic: 1,2
	*/
	this.selectRow = function(r,fl){
						if(typeof(r)!='object')
							r = this.rowsCol[r]
						this.selectCell(r,0,fl)
					};
	/**
	*	@desc: sorts specified column
	*	@param: col - column index
	*	@param:	type - str.int.date
	*	@param: order - asc.desc
	*	@type: public
	*	@topic: 2,3,5,9
	*/
	this.sortRows = function(col,type,order){
						//if tree cell exists
						if(this.cellType.find("tree")!=-1){
							return this.sortTreeRows(col,type,order)
						}
						if(type=='str'){
							this.rowsCol.sort(function(a,b){
													var cA = a.childNodes[col]
													var cB = b.childNodes[col]
													var type = a.grid.cellType[col];
													eval("var edA = new eXcell_"+type+"(cA)")
													eval("var edB = new eXcell_"+type+"(cB)")
													if(order=="asc")
														return edA.getValue()>edB.getValue()?1:-1
													else
														return edA.getValue()<edB.getValue()?1:-1
												});
						}else if(type=='int'){
							this.rowsCol.sort(function(a,b){
													var cA = a.childNodes[col]
													var cB = b.childNodes[col]
													var type = a.grid.cellType[col];
													eval("var edA = new eXcell_"+type+"(cA)")
													eval("var edB = new eXcell_"+type+"(cB)")
													var aVal = parseFloat(edA.getValue())||-99999999999999
													var bVal = parseFloat(edB.getValue())||-99999999999999
													if(order=="asc")
														return aVal-bVal
													else
														return bVal-aVal
													
												});
						}else if(type=='date'){
							this.rowsCol.sort(function(a,b){
													var cA = a.childNodes[col]
													var cB = b.childNodes[col]
													var type = a.grid.cellType[col];
													eval("var edA = new eXcell_"+type+"(cA)")
													eval("var edB = new eXcell_"+type+"(cB)")
													var aVal = Date.parse(new Date(edA.getValue())||new Date("01/01/1900"))
													var bVal = Date.parse(new Date(edB.getValue())||new Date("01/01/1900"))
													if(order=="asc")
														return aVal-bVal
													else
														return bVal-aVal
													
												});
						}
						if(this.dynScroll && this.dynScroll!='false'){
							alert("not implemented yet")
						}else{
							var tb = this.obj.firstChild;
							for(var i=0;i<this.rowsCol.length;i++){
									tb.insertBefore(this.rowsCol[i],tb.childNodes[i])
									//tb.moveRow(this.rowsCol[i].rowIndex,i)
							}
						}
						this.setSizes()
					}
	
	/**
	*	@desc: adds row to the specified position
	*	@param: new_id - id for new row
	*	@param: text - Array of values or String(with delimiter as in delimiter parameter)
	*	@param: [ind] - index of row (0 by default)
	*	@returns: new row dom object
	*	@type: public
	*	@topic: 2
	*/
	this.addRow	= 	function(new_id,text,ind){
						//alert_a("A:"+(new Date()).valueOf())
							if(arguments.length<3)
								ind = this.rowsCol.length//getRowsNum();
							else{
								if(ind>this.rowsCol.length)
									ind = this.rowsCol.length;
							}
							if(typeof(text)!='object')
								text = text.split(this.delim)
							var r = this.obj.insertRow(this.obj.rows.length);
								if(this.multiLine != true)
									r.style.height = "20px";
								r.idd = new_id;
								r.grid = this;
						//alert_a("B:"+(new Date()).valueOf())
							for(var i=0;i<this.hdr.rows[0].cells.length;i++){
								var c = r.insertCell(i)
									c.align = this.cellAlign[i]
									//add color to column
									c.bgColor = this.columnColor[i] || ""
									this.editStop();
								if(i<text.length){
									var val = text[i]
									eval("this.editor = new eXcell_"+this.cellType[i]+"(c)");
									this.editor.setValue(val)
									this.editor = null
								}else{
									var val = "&nbsp;";
									c.innerHTML = val;
								}	
									
							}
							this.rowsAr[new_id] = r;
							this.rowsCol.insertAt(ind,r);
							if(!this.dynScroll || this.dynScroll=='false' || ind<this.obj.rows.length){
								try{
									this.obj.firstChild.insertBefore(r,this.obj.rows[ind])
								}catch(er){
									//alert(er)
								}
							}/*else{
								r.removeNode(true)
							}*/
							this.chngCellWidth(ind)
							this.doOnRowAdded(r);
							return r;
					}
	/**
	*	@desc: enables the possibility to load content from server when already loaded content was rendered. Using this you decrease the grid loading time for extremely big amounts of data.
	*	@type: public
	*	@topic: 0,7
	*/
	this.setXMLAutoLoading = function(filePath,bufferSize){
		this.recordsNoMore = false;
		this.xmlFileUrl = filePath;
		this.rowsBufferOutSize = bufferSize||40;
	}
	
	/**
	*	@desc: enables buffering in content rendering. Using this you decrease the grid loading time.
	*	@type: public
	*	@topic: 0,7
	*/
	this.enableBuffering = function(bufferSize){
		this.rowsBufferOutSize = bufferSize||40;
	}

	/**
	*	@desc: create rows from another part of buffer
	*	@type: private
	*	@topic: 0,2,7
	*/
	this.addRowsFromBuffer = function(){
		if(this.rowsBuffer[0].length==0){
			if(!this.recordsNoMore){
				if(this.xmlFileUrl!=""){
					this.parseXML(this.xmlFileUrl,this.rowsCol.length)
				}
			}else
				return false;
		}
		var cnt = Math.min(this.rowsBufferOutSize,this.rowsBuffer[0].length)
		//this.rowsBuffer.length
		for(var i=0;i<cnt;i++){
			var rowNode = this.rowsBuffer[1][0]
			var rId = rowNode.getAttribute("id")
			var cellsCol = rowNode.childNodes;
			var strAr = new Array(0);
			for(var j=0;j<cellsCol.length;j++){
				strAr[strAr.length] = cellsCol.item(j).text||cellsCol.item(j).textContent
			}
			var r = this.addRow(rId,strAr)
			//select row
			if(rowNode.getAttribute("selected")==true){
				this.setSelectedRow(rId,false,false,rowNode.getAttribute("call")==true)
			}
			//expand
			if(rowNode.getAttribute("expand")=="1"){
				r.expand = "";
			}
			this.rowsBuffer[0].removeAt(0);
			this.rowsBuffer[1].removeAt(0);
		}
		return true;
	}
	
	/**
	*	@desc: allow multiselection
	*	@param: fl - false/true
	*	@type: public
	*	@before_init: 1
	*	@topic: 0,2,7
	*/
	this.setMultiselect = function(fl){
		this.selMultiRows = fl;
	}
	/**
	*	@desc: deletes row
	*	@param: row_id - id of row to delete
	*	@type: public
	*	@topic: 2,9
	*/
	this.deleteRow = function(row_id){
							/*if(this.row!=null && row_id==this.row.idd){
								this.deleteSelectedItem();
							}else{*/
								var node = this.getRowById(row_id)
								//treegrid
								if(this.cellType.find("tree")!=-1){
									var parent_id = node.parent_id
									this.collapseKids(node)
									var tmpAr = this.loadedKidsHash.get(parent_id)
									if(tmpAr!=null)
										tmpAr.removeAt(tmpAr.find(node))
									this.loadedKidsHash.remove(node.idd)
								}
								//..
								if(node!=null){
									this.obj.firstChild.removeChild(node);//nb:node.removeNode(true);
									this.rowsCol.removeAt(this.rowsCol.find(node))
									node = null;
								}
							//}
							
							this.rowsAr[row_id] = null;
						}
	/**
	*	@desc: deletes selected row(s)
	*	@type: public
	*	@topic: 2
	*/
	this.deleteSelectedItem = function(){
							var num = this.selectedRows.length//this.obj.rows.length
							if(num==0)
								return;
							for(var i=num-1;i>=0;i--){
								var node = this.selectedRows[i]
									if(node==this.row){
										var ind = i;
									}
									var parent_id = node.parent_id
									//treegrid
										if(parent_id){
											this.collapseKids(node)
											var tmpAr = this.loadedKidsHash.get(parent_id)
											if(tmpAr!=null)
												tmpAr.removeAt(tmpAr.find(node))
										}
									//..
									this.rowsAr[node.idd] = null;
									var posInCol = this.rowsCol.find(node)
									this.rowsCol[posInCol].parentNode.removeChild(this.rowsCol[posInCol]);//nb:this.rowsCol[posInCol].removeNode(true);
									this.rowsCol.removeAt(posInCol)
							}
							this.selectedRows = new Array(0)
							if(ind){
								try{
									if(ind+1>this.rowsCol.length)//this.obj.rows.length)
										ind--; 
									this.selectCell(ind,0,true)
								}catch(er){
									this.row = null
									this.cell = null
								}
							}
						}
	
	/**
	*	@desc: gets selected row id
	*	@returns: id of selected row (list of ids with default delimiter) or null if non row selected
	*	@type: public
	*	@topic: 1,2,9
	*/
	this.getSelectedId = function(){
							var selAr = new Array(0);
							for(var i=0;i<this.selectedRows.length;i++){
								selAr[selAr.length]=this.selectedRows[i].idd
							}
							
							//..
							if(selAr.length==0)
								return null;
							else
								return selAr.join(this.delim);
						}
	/**
	*	@desc: gets index of selected cell
	*	@returns: index of selected cell or -1 if there is no selected sell
	*	@type: public
	*	@topic: 1,4
	*/
	this.getSelectedCellIndex = function(){
									if(this.cell!=null)
										return this.cell.cellIndex;
									else
										return -1;
								}
	/**
	*	@desc: gets width of specified column in pixels
	*	@param: ind - column index
	*	@returns: column width in pixels
	*	@type: public
	*	@topic: 3,7
	*/
	this.getColWidth = function(ind){
									return parseInt(this.cellWidthPX[ind]);
								}
	/**
	*	@desc: gets row object by id
	*	@param: id - row id
	*	@returns: row object or null if there is no row with specified id
	*	@type: private
	*	@topic: 2,7,9
	*/
	this.getRowById = function(id){
						var row = this.rowsAr[id]
						if(row)
							return row;
						else
							return null;
					}
	/**
	*	@desc: gets row index by id (grid only)
	*	@param: row_id - row id
	*	@returns: row index or -1 if there is no row with specified id
	*	@type: public
	*	@topic: 2
	*/
	this.getRowIndex = function(row_id){
								var ind = this.rowsCol.find(this.getRowById(row_id));
								if(ind!=-1)
									return ind;
								else{
									ind = this.rowsBuffer[0].find(row_id)
									if(ind!=-1)
										return ind+this.rowsCol.length;
									return -1;
								}
						}
	/**
	*	@desc: gets row id by index
	*	@param: ind - row index
	*	@returns: row id or null if there is no row with specified index
	*	@type: public
	*	@topic: 2
	*/
	this.getRowId = function(ind){
							try{
								return this.rowsCol[parseInt(ind)].idd;
							}catch(er){
								return this.rowsBuffer[0][ind-this.rowsCol.length-1]
								//return null;
							}
						}
	/**
	*	@desc: sets new id for row by its index
	*	@param: ind - row index
	*	@param: row_id - new row id
	*	@type: public
	*	@topic: 2
	*/
	this.setRowId = function(ind,row_id){
							var r = this.rowsCol[ind]
							r.idd = row_id;
							this.rowsAr[row_id] = r;
						}
	/**
	*	@desc: sets ids to every column. Can be used then to retreive the index of the desired colum
	*	@param: [ids] - "," delimitered list of ids, or empty if to use values set earlier
	*	@type: public
	*	@topic: 3
	*/
	this.setColumnIds = function(ids){
							if(ids)
								this.columnIds = ids.split(",")
							if(this.hdr.rows[0].cells.length==this.columnIds.length){
								for(var i=0;i<this.hdr.rows[0].cells.length;i++){
									this.hdr.rows[0].cells[i].column_id = this.columnIds[i];
								}
							}
						}
	/**
	*	@desc: gets column index by column id
	*	@param: id - column id
	*	@returns: index of the column
	*	@type: public
	*	@topic: 3
	*/
	this.getColIndexById = function(id){
							for(var i=0;i<this.hdr.rows[0].cells.length;i++){
								if(this.hdr.rows[0].cells[i].column_id==id)
									return i;
							}
						}
	/**
	*	@desc: gets column id of column specified by index
	*	@param: cin - column index
	*	@returns: column id
	*	@type: public
	*	@topic: 3
	*/
	this.getColumnId = function(cin){
							return this.hdr.rows[0].cells[cin].column_id
						}
	
	/**
	*	@desc: sets row text BOLD
	*	@param: row_id - row id
	*	@type: public
	*	@topic: 2,6
	*/
	this.setRowTextBold = function(row_id){
							this.getRowById(row_id).style.fontWeight = "bold";
						}
	/**
	*	@desc: sets style to row
	*	@param: row_id - row id
	*	@param: styleString - style string in common format (exmpl: "color:red;border:1px solid gray;")
	*	@type: public
	*	@topic: 2,6
	*/
	this.setRowTextStyle = function(row_id,styleString){
							var r = this.getRowById(row_id)
							for(var i=0;i<r.cells.length;i++){
								(r.cells[i].runtimeStyle||r.cells[i].style).cssText = styleString;
							}
							
						}
	/**
	*	@desc: sets row text NORMAL
	*	@param: row_id - row id
	*	@type: public
	*	@topic: 2,6
	*/
	this.setRowTextNormal = function(row_id){
							this.getRowById(row_id).style.fontWeight = "normal";
						}
	/**
	*	@desc: determines if row with specified id exists
	*	@param: row_id - row id
	*	@returns: true if exists, false otherwise
	*	@type: public
	*	@topic: 2,7
	*/
	this.isItemExists = function(row_id){
							if(this.getRowById(row_id)!=null)
								return true
							else
								return false
						}
	/**
	*	@desc: gets a list of all row ids in grid
	*	@param: separator - delimiter to use in list
	*	@returns: list of all row ids in grid
	*	@type: public
	*	@topic: 2,7
	*/
	this.getAllItemIds = function(separator){
							var ar = new Array(0)
							for(i=0;i<this.rowsCol.length;i++){
								ar[ar.length]=this.rowsCol[i].idd
							}
							for(i=0;i<this.rowsBuffer[0].length;i++){
								ar[ar.length]=this.rowsBuffer[0][i]
							}
							return ar.join(separator||",")
						}
	/**
	*	@desc: gets number of rows in grid
	*	@returns: number of rows in grid
	*	@type: public
	*	@topic: 2,7
	*/
	this.getRowsNum = function(){
							return this.rowsCol.length+this.rowsBuffer[0].length;
						}
	/**
	*	@desc: gets number of columns in grid
	*	@returns: number of columns in grid
	*	@type: public
	*	@topic: 3,7
	*/
	this.getColumnCount = function(){
							return this.hdr.rows[0].cells.length;
						}
	/**
	*	@desc: moves row one position up if possible
	*	@param: row_id -  row id
	*	@type: public
	*	@topic: 2
	*/
	this.moveRowUp = function(row_id){
							var r = this.getRowById(row_id)
							var rInd = this.rowsCol.find(r)
							this.rowsCol.swapItems(rInd,rInd-1)
							try{
									this.obj.firstChild.insertBefore(r,r.previousSibling)
							}catch(er){alert('Caught error in MoveRowUp method: '+(er.description||er))}
						}
	/**
	*	@desc: moves row one position down if possible
	*	@param: row_id -  row id
	*	@type: public
	*	@topic: 2
	*/
	this.moveRowDown = function(row_id){
							var r = this.getRowById(row_id)
							var rInd = this.rowsCol.find(r)
							this.rowsCol.swapItems(rInd,rInd+1)
							try{
									this.obj.firstChild.insertBefore(r,r.nextSibling.nextSibling)
							}catch(er){alert('Caught error in MoveRowDown method: '+er.description)}
						}
	/**
	*	@desc: gets dhtmlXGridCellObject object (if no arguments then gets dhtmlXGridCellObject object of currently selected cell)
	*	@param: row_id -  row id
	*	@param: col -  column index
	*	@returns: dhtmlXGridCellObject object (see its methods below)
	*	@type: public
	*	@topic: 4
	*/
	this.cells = function(row_id,col){
							if(arguments.length==0){
								var c = this.cell;
								return eval("new eXcell_"+this.cellType[this.cell.cellIndex]+"(c)");
							}else{
								var c = this.getRowById(row_id).childNodes[col];
								return eval("new eXcell_"+this.cellType[col]+"(c)");
							}
						}
	/**
	*	@desc: gets dhtmlXGridCellObject object
	*	@param: row_index -  row index
	*	@param: col -  column index
	*	@returns: dhtmlXGridCellObject object (see its methods below)
	*	@type: public
	*	@topic: 4
	*/
	this.cells2 = function(row_index,col){
							var c = this.rowsCol[parseInt(row_index)].cells[parseInt(col)];
							return eval("new eXcell_"+this.cellType[c.cellIndex]+"(c)");
						}
	/**
	* @desc: gets Combo object of specified column
	*	@type: public
	*	@topic: 3,4
	*	@param: col_ind - index of the column to get combo object for
	*/
	this.getCombo = function(col_ind){
		if(this.cellType[col_ind].indexOf('co')==0){
			if(this.combos[col_ind]==null){
				this.combos[col_ind] = new dhtmlXGridComboObject();
			}
			return this.combos[col_ind];
		}else{
			return null;
		}
	}
	/**
	*	@desc: sets user Data
	*	@param: row_id -  row id. if empty then user data is for grid (not row)
	*	@param: name -  name of user data
	*	@param: value -  value of user data
	*	@type: public
	*	@topic: 2,5
	*/
	this.setUserData = function(row_id,name,value){
							try{
								if(row_id=="")
									row_id = "gridglobaluserdata";
								this.UserData[row_id][name] = value
							}catch(er){}
						}
	/**
	*	@desc: gets user Data
	*	@param: row_id -  row id. if empty then user data is for grid (not row)
	*	@param: name -  name of user data
	*	@returns: value of user data
	*	@type: public
	*	@topic: 2,5
	*/
	this.getUserData = function(row_id,name){
							try{
								if(row_id=="")
									row_id = "gridglobaluserdata";
								return this.UserData[row_id][name]
							}catch(er){}
						}
	
	/**
	*	@desc: manage editibility of the grid
	*	@param: [fl] - set not editable if FALSE, set editable otherwise
	*	@type: public
	*	@topic: 7
	*/
	this.setEditable = function(fl){
							if(fl!='true' && fl!=1 && fl!=true)
								ifl = true;
							else
								ifl = false;
							for(var j=0;j<this.cellType.length;j++){
								if(this.cellType[j].indexOf('ra')==0 || this.cellType[j]=='ch'){
									for(var i=0;i<this.rowsCol.length;i++){
										if(this.rowsCol[i].cells[j].childNodes.length>0){
											this.rowsCol[i].cells[j].firstChild.disabled = ifl;
										}
									}			
								}
							}
							this.isEditable = !ifl;
						}
	/**
	*	@desc: selects row
	*	@param: row_id - row id
	*	@param: multiFL - VOID. select multiple rows
	*	@param: show - VOID. scroll row to view
	*	@param: call - true to call function on select
	*	@type: public
	*	@topic: 1,2
	*/
	this.setSelectedRow = function(row_id, multiFL,show,call){
							if(!call)
								call = false;
							this.selectCell(this.getRowById(row_id),0,call);//selectRow(this.getRowById(row_id),false)
							if(arguments.length>2 && show==true){
								this.moveToVisible(this.getRowById(row_id).cells[0])	
							}
						}
	/**
	*	@desc: removes selection from the grid
	*	@type: public
	*	@topic: 1,9
	*/
	this.clearSelection = function(){
							this.editStop()
							for(var i=0;i<this.selectedRows.length;i++){
								this.selectedRows[i].className = "";
							}
							
							//..
							this.selectedRows = new Array(0)
							this.row = null;
							if(this.cell!=null){
								this.cell.className = "";
								this.cell = null;
							}
						}
	/**
	*	@desc: copies row content to another existing row
	*	@param: from_row_id - id of the row to copy content from
	*	@param: to_row_id - id of the row to copy content to
	*	@type: public
	*	@topic: 2,5
	*/
	this.copyRowContent = function(from_row_id, to_row_id){
							var frRow = this.getRowById(from_row_id)
							for(i=0;i<frRow.cells.length;i++){
								this.cells(to_row_id,i).setValue(this.cells(from_row_id,i).getValue())
							}
							//for Mozilla (to avaoid visual glitches)
							if(!isIE())
								this.getRowById(from_row_id).cells[0].height = frRow.cells[0].offsetHeight
						}
	/**
	*	@desc: sets new column header label
	*	@param: col - header column index
	*	@param: label - new label for the cpecified header's column
	*	@type: public
	*	@topic: 3,6
	*/
	this.setHeaderCol = function(col,label){
							this.hdr.rows[0].cells[Number(col)].innerHTML = label;
						}
	/**
	*	@desc: deletes all rows in grid
	*	@type: public
	*	@topic: 5,7,9
	*/
	this.clearAll = function(){
							//debugger;
							var len = this.rowsCol.length;
							for(var i=len-1;i>=0;i--){
								this.obj.firstChild.removeChild(this.rowsCol[i])//nb:this.rowsCol[i].removeNode(true);
								this.rowsCol.removeAt(i);
							}
							//treegrid
							if(this.loadedKidsHash!=null){
								this.loadedKidsHash.clear();
							}
							//for some case
							len = this.obj.rows.length
							for(var i=len-1;i>=0;i--){
								this.obj.firstChild.removeChild(this.obj.rows[i])//nb:this.obj.rows[i].removeNode(true);
							}
							//..
							this.row = null;
							this.cell = null;
							this.rowsAr = new Array(0)
							this.rowsCol = new Array(0)
						}
	this._sortField = function(ev){
							var el = this.getFirstParentOfType(ev.target||ev.srcElement,"TD");
							this.sortField(el.cellIndex)	
						}
	/**
	*	@desc: sorts grid by specified field
	* 	@invoke: header click
	*	@param: [ind] - index of the field
	*	@param: [repeatFl] - if to repeat last sorting
	*	@type: private
	*	@topic: 3
	*/
	this.sortField = function(ind,repeatFl){
						if(this.getRowsNum()==0)
							return false;
						var el = this.hdr.rows[0].cells[ind];
						if(el.tagName == "TD" && (this.fldSort.length-1)>=el.cellIndex && this.fldSort[el.cellIndex]!='na'){//this.entBox.fieldstosort!="" &&
							if(((this.sortImg.src.indexOf("_desc.gif")==-1 && !repeatFl) || (this.sortImg.style.filter!="" && repeatFl)) && this.fldSorted==el){//desc
								var sortType = "desc";
								this.sortImg.src = this.imgURL+"sort_desc.gif";
							}else{//asc
								var sortType = "asc";
								this.sortImg.src = this.imgURL+"sort_asc.gif";
							}
							this.sortRows(el.cellIndex,this.fldSort[el.cellIndex],sortType)
							this.fldSorted = el;
							this.setSortImgPos();
						}
					}
	
	/**
	*	@desc: set header label and default params for new headers 
	*	@param: hdrStr - header string with delimiters
	*	@type: public
	*	@before_init: 1
	*	@topic: 0,3
	*/
	this.setHeader = function(hdrStr){
		var arLab = hdrStr.split(this.delim);
		var arWdth = new Array(0);
		var arTyp = new Array(0);
		var arAlg = new Array(0);
		var arSrt = new Array(0);
		for(var i=0;i<arLab.length;i++){
			arWdth[arWdth.length] = Math.round(100/arLab.length);
			arTyp[arTyp.length] = "ed";
			arAlg[arAlg.length] = "left";
			arSrt[arSrt.length] = "na";
		}
		this.hdrLabels = arLab;
		this.cellWidth = arWdth;
		this.cellType =  arTyp;
		this.cellAlign =  arAlg;
		this.fldSort = arSrt;
	}
	/**
	*	@desc: set column types
	*	@param: typeStr - type codes list with default delimiter
	*	@before_init: 2
	*	@type: public
	*	@topic: 0,3,4
	*/
	this.setColTypes = function(typeStr){
		this.cellType = typeStr.split(this.delim)
	}
	/**
	*	@desc: set column sort types (avaialble: str, int, date, na)
	*	@param: sortStr - sort codes list with default delimiter
	*	@before_init: 1
	*	@type: public
	*	@topic: 0,3,4
	*/
	this.setColSorting = function(sortStr){
		this.fldSort = sortStr.split(this.delim)
	}
	/**
	*	@desc: set align of columns
	*	@param: alStr - align string with delimiters
	*	@before_init: 1
	*	@type: public
	*	@topic: 0,3
	*/
	this.setColAlign = function(alStr){
		this.cellAlign = alStr.split(this.delim)
	}
	
	/**
	*	@desc: sets grid to multiline row support (call before init)
	*	@param:	fl - true to set multiline support
	*	@type: public
	*	@before_init: 1
	*	@topic: 0,2
	*	@problem: 'false' value - doesn't work in Mozilla
	*/
	this.setMultiLine = function(fl){
		if(fl==true)
			this.multiLine = -1;
	}
	/**
	*	@desc: use to create grid with no header
	*	@param: fl - true to use no header in the grid
	*	@type: public
	*	@before_init: 1
	*	@topic: 0,7
	*/
	this.setNoHeader = function(fl){
		if(fl==true)
			this.noHeader = -1;
	}
	/**
	*	@desc: scrolls row to the visible area
	*	@param: rowID - row id
	*	@type: public
	*	@topic: 2,7
	*/
	this.showRow = function(rowID){
		this.moveToVisible(this.getRowById(rowID).cells[0])	
	}
	
	/**
	*	@desc: modify default style of grid and its elements. Call before or after Init
	*	@param: ss_header - style def. expression for header
	*	@param: ss_grid - style def. expression for grid cells
	*	@param: ss_selCell - style def. expression for selected cell
	*	@param: ss_selRow - style def. expression for selected Row
	*	@type: public
	*	@before_init: 2
	*	@topic: 0,6
	*/
	this.setStyle = function(ss_header,ss_grid,ss_selCell,ss_selRow){
		this.ssModifier = new Array(4)
		this.ssModifier[0] = ss_header;
		this.ssModifier[1] = ss_grid;
		this.ssModifier[2] = ss_selCell;
		this.ssModifier[3] = ss_selRow;
		this.styleSheet.addRule("#"+this.entBox.id+" table.hdr td",this.ssHeader+""+this.ssModifier[0]);
		this.styleSheet.addRule("#"+this.entBox.id+" table.obj td",this.ssGridCell+""+this.ssModifier[1]);
		this.styleSheet.addRule("#"+this.entBox.id+" table.obj tr.rowselected td.cellselected",this.ssSelectedCell+""+this.ssModifier[2]);
		this.styleSheet.addRule("#"+this.entBox.id+" table.obj td.cellselected",this.ssSelectedCell+""+this.ssModifier[2])
		this.styleSheet.addRule("#"+this.entBox.id+" table.obj tr.rowselected td",this.ssSelectedRow+""+this.ssModifier[3]);
	}
	/**
	*	@desc: colorize columns.
	*	@param: clr - colors list
	*	@type: public
	*	@before_init: 1
	*	@topic: 3,6
	*/
	this.setColumnColor = function(clr){
		this.columnColor = clr.split(this.delim)
	}
	
	/**
	*	@desc: dynamicaly scrolls grid content.
	*	@param: fl - if no fl - initializes dynamic scroll, if 'up' - scroll page up, if 'dn' - scrolls page down
	*	@type: public
	*	@topic: 0,6,7,9
	*/
	this.doDynScroll = function(fl){
		if(!this.dynScroll || this.dynScroll=='false')
			return false;
		this.objBox.style.overflowY = "hidden";
		this.setDynScrollPageSize();
		//alert("dynscroll")
		var tmpAr = new Array(0)
		if(fl && fl=='up'){
			this.dynScrollPos = Math.max(this.dynScrollPos-this.dynScrollPageSize,0);
		}else if(fl && fl=='dn' && this.dynScrollPos+this.dynScrollPageSize<this.rowsCol.length){
			if(this.dynScrollPos+this.dynScrollPageSize+this.rowsBufferOutSize>this.rowsCol.length){
				alert(2)
				this.addRowsFromBuffer()
			}
			this.dynScrollPos+=this.dynScrollPageSize
		}
		var start = Math.max(this.dynScrollPos-this.dynScrollPageSize,0);
		for(var i = start;i<this.rowsCol.length;i++){
			if(i>=this.dynScrollPos && i<this.dynScrollPos+this.dynScrollPageSize){
				tmpAr[tmpAr.length] = this.rowsCol[i];
			}
			this.rowsCol[i].removeNode(true);
		}
		for(var i=0;i<tmpAr.length;i++){
			this.obj.childNodes[0].appendChild(tmpAr[i]);
			if(this.obj.offsetHeight>this.objBox.offsetHeight)
				this.dynScrollPos-=(this.dynScrollPageSize-i)
		}
		this.setSizes()
	}
	/**
	*	@desc: counts the number of rows to fit the grid for dyn scroll
	*	@type: private
	*	@topic: 0
	*/
	this.setDynScrollPageSize = function(){			
				if(this.dynScroll && this.dynScroll!='false'){
					var rowsH = 0;
					try{
						var rowH = this.obj.rows[0].scrollHeight;
					}catch(er){
						var rowH = 20
					}
					for(var i=0;i<1000;i++){
						rowsH = i*rowH;
						if(this.objBox.offsetHeight<rowsH)
							break
					}
					this.dynScrollPageSize = i+ 2;//parseInt(i/3.5);
					this.rowsBufferOutSize = this.dynScrollPageSize * 4
				}
	}
/*SET EVENT HANDLERS*/
	/**  
	*     @desc: set function called when row selected
	*     @param: func - event handling function (or its name)
	*     @type: public
	*     @topic: 10  
	*	@event: onRowSelect
	*     @eventdesc: Event raised immideatly after row was clicked.
	*     @eventparam:  ID of clicked row
	*/
	this.setOnRowSelectHandler = function(func){
		if(!func)
			this.onRowSelect = "void";
		else
			if (typeof(func)=="function") 
				this.onRowSelect=func; 
			else 
				this.onRowSelect=eval(func);
	}
	
	/**  
	*     @desc: set function called when cell editted
	*     @param: func - event handling function (or its name)
	*     @type: public
	*     @topic: 10  
	*	@event: onEditCell
	*     @eventdesc: Event raises 1-3 times depending on cell editibality.
	*     @eventparam:  stage of editting (0-before start[can be canceled if returns false],1-editor opened,2-editor closed)
	*     @eventparam:  ID or row
	*     @eventparam:  index of cell
	*/
	this.setOnEditCellHandler = function(func){
		if(!func)
			this.onEditCell = "void";
		else
			if (typeof(func)=="function") 
				this.onEditCell=func; 
			else 
				this.onEditCell=eval(func);
	}
	/**  
	*     @desc: set function called when checkbox or radiobutton was clicked
	*     @param: func - event handling function (or its name)
	*     @type: public
	*     @topic: 10  
	*	@event: onCheck
	*     @eventdesc: Event raises after state was changed.
	*     @eventparam:  ID or row
	*     @eventparam:  index of cell
	*	  @eventparam:  state of checkbox/radiobutton
	*/
	this.setOnCheckHandler = function(func){
		if(!func)
			this.onCheckbox = "void";
		else
			if (typeof(func)=="function") 
				this.onCheckbox=func; 
			else 
				this.onCheckbox=eval(func);
	}
	
	/**  
	*     @desc: set function called when user press Enter
	*     @param: func - event handling function (or its name)
	*     @type: public
	*     @topic: 10  
	*	@event: onEnterPressed
	*     @eventdesc: Event raised immideatly after Enter pressed.
	*     @eventparam:  ID or row
	*     @eventparam:  index of cell
	*/
	this.setOnEnterPressedHandler = function(func){
		if(!func)
			this.onEnter = "void";
		else
			if (typeof(func)=="function") 
				this.onEnter=func; 
			else 
				this.onEnter=eval(func);
	}
	
/*TOOLS METHODS*/
	/**
	*	@desc: creates XML object from what was returned from specified URL (if possible)
	*	@returns: MS XML object
	*	@param: url - url of the xml formated page
	*	@type: private
	*	@topic: 8
	*/
	/*this.loadXML = function(url){
						if(/\?/g.test(url))
							var s = "&";
						else
							var s = "?";
						var xmlDoc = new ActiveXObject("microsoft.XMLDOM");
						xmlDoc.async = false;
						xmlDoc.load(url+""+s+"rowsLoaded="+this.getRowsNum()+"&"+Date.parse(new Date()))
						return xmlDoc;
					}*/
	/**
	* 	@desc: returns absolute left and top position of specified element
	* 	@returns: array of two values: absolute Left and absolute Top positions
	* 	@param: oNode - element to get position of
	*	@type: private
	*	@topic: 8
	*/
	this.getPosition = function(oNode,pNode){
					   if(!pNode)
					   		var pNode = document.body
					   var oCurrentNode=oNode;
					   var iLeft=0;
					   var iTop=0;
					   while(oCurrentNode!=pNode){//.tagName!="BODY"){
					      	iLeft+=oCurrentNode.offsetLeft;
						  	iTop+=oCurrentNode.offsetTop;
					      	oCurrentNode=oCurrentNode.offsetParent;//isIE()?:oCurrentNode.parentNode;
					   }
					   return new Array(iLeft,iTop);
					}
	/**
	*	@desc: gets nearest parent of specified type
	*	@param: obj - input object
	*	@param: tag - string. tag to find as parent
	*	@returns: object. nearest paraent object (including spec. obj) of specified type. 
	*	@type: private
	*	@topic: 8
	*/
	this.getFirstParentOfType = function(obj,tag){
		while(obj.tagName!=tag && obj.tagName!="BODY"){
			obj = obj.parentNode;
		}
		return obj;
	}
	
/*METHODS deprecated*/
	/**
	*	@desc: deprecated. sets number of columns
	*	@param: cnt - number of columns
	*	@type: void
	*	@topic: 3,7
	*/
	this.setColumnCount = function(cnt){alert('setColumnCount method deprecated')}
	/**
	*	@desc: deprecated. repaint of the grid
	*	@topic: 7
	*	@type: void
	*/
	this.showContent = function(){alert('showContent method deprecated')}
	
/*INTERNAL EVENT HANDLERS*/
	this.objBox.onscroll = new Function("","this.grid.doOnScroll()")
	this.hdr.onmousemove = new Function("e","this.grid.changeCursorState(e||window.event)");
	this.hdr.onmousedown = new Function("e","this.grid.startColResize(e||window.event)");
	//nb:this.entBox.onresize = new Function("","this.grid.setSizes(true)")
	this.obj.onmousemove = new Function("e","(e?e.target:event.srcElement).title = e?e.target.textContent:event.srcElement.innerText");
	this.entBox.onclick = new Function("e","this.grid._doClick(e||window.event)");
	this.obj.ondblclick = new Function("e","this.grid.editCell(e||window.event)");
	this.hdr.onclick = new Function("e","if(this.grid.resized==null)this.grid._sortField(e||window.event);");
	//VOID this.grid.ondblclick = this.onDoubleClick;
	document.onkeydown = new Function("e","document.getElementById('"+this.entBox.id+"').grid.doKey(e||window.event)");
//nb:document.body.attachEvent("onclick",new Function("","if(this.document.getElementById('"+this.entBox.id+"').grid.isActive==-1)this.document.getElementById('"+this.entBox.id+"').grid.setActive(false)"))
	//activity management
	this.entBox.onbeforeactivate = new Function("","this.grid.setActive()");
	this.entBox.onbeforedeactivate = new Function("","this.grid.isActive=-1");
	//postprocessing events (method can be redeclared to react on some events during processing)
	this.doOnRowAdded = function(row){};
	
}


